package de.donmanfred;

import com.github.silvestrpredko.dotprogressbar.DotProgressBar;

import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import android.view.WindowManager.LayoutParams;
import android.widget.CompoundButton;
import android.widget.Switch;
import android.widget.CompoundButton.OnCheckedChangeListener;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.DesignerProperties;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.Property;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.CustomViewWrapper;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.collections.Map;

@Version(1.00f)
@ShortName("DotProgressBar")
@Author(value = "DonManfred (wrapper)")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
//@Events(values={"onSigned(sign As Object)"})
//@DependsOn(values={"android-viewbadger"})
@DesignerProperties(values = {
		@Property(key="DotAmount", displayName="DotAmount", defaultValue="5", fieldType="Int"),
		@Property(key="AnimationTime", displayName="AnimationTime", defaultValue="500", fieldType="Int"),
		@Property(key="StartColor", displayName="StartColor", defaultValue="0xFFCFDCDC", fieldType="Color"),
		@Property(key="EndColor", displayName="EndColor", defaultValue="0xFFaaDCaa", fieldType="Color")
})
public class DotProgressBarWrapper extends ViewWrapper<DotProgressBar> implements DesignerCustomView{
	private BA ba;
	private String eventName;

	@Override
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, Map props) {
		getObject().setDotAmount((int) props.Get("DotAmount"));
		getObject().setAnimationTime((int) props.Get("AnimationTime"));
		getObject().setStartColor((int) props.Get("StartColor"));
		getObject().setEndColor((int) props.Get("EndColor"));
		CustomViewWrapper.replaceBaseWithView(base, getObject());
	}
	public void Initialize(final BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	@Override
	public void _initialize(final BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;

		final DotProgressBar _obj = new DotProgressBar(ba.context);
		final String eventName = EventName.toLowerCase(BA.cul);
		setObject(_obj);
		innerInitialize(ba, eventName, true);
	}
  public void setDotAmount(int amount) {
  	this.getObject().setDotAmount(amount);
  }

  public void setStartColor(int color) {
  	this.getObject().setStartColor(color);
  }

  public void setEndColor(int color) {
  	this.getObject().setEndColor(color);
  }

  public void setAnimationTime(int animationTime) {
  	this.getObject().setAnimationTime(animationTime);
  }

  public int darker(int color, float factor) {
    int a = Color.alpha(color);
    int r = Color.red(color);
    int g = Color.green(color);
    int b = Color.blue(color);

    return Color.argb(a,
        Math.max((int) (r * factor), 0),
        Math.max((int) (g * factor), 0),
        Math.max((int) (b * factor), 0));
  }
	
}
